/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: SimpleFinderSupport.java,v 3e7ea5dbefcb 2010/05/17 15:10:54 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.observation.simple;

import javax.annotation.Nonnegative;
import javax.annotation.Nonnull;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import it.tidalwave.bluebill.observation.Finder;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class SimpleFinderSupport<T> extends it.tidalwave.util.FinderSupport<T> implements Finder<T>
  {
    @Nonnull
    private final List<T> contents;

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public SimpleFinderSupport (final @Nonnull Set<T> contents)
      {
        this(new ArrayList<T>(contents));
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public SimpleFinderSupport (final @Nonnull List<T> contents)
      {
        super("xxx");
        this.contents = contents;
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    public Finder<T> clone()
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    @Nonnull
    public Finder<T> from (@Nonnegative int firstResult)
      {
        return (Finder<T>)super.from(firstResult);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    @Nonnull
    public Finder<T> max (@Nonnegative int maxResults)
      {
        return (Finder<T>)super.max(maxResults);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    public Finder<T> sort (@Nonnull Finder.SortCriterion criterion, @Nonnull Finder.SortDirection direction)
      {
        return (Finder<T>)super.sort(criterion, direction);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    public Finder<T> sort (@Nonnull Finder.SortCriterion criterion)
      {
        return (Finder<T>)super.sort(criterion);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    protected List<T> doCompute()
      {
        return contents;
      }
  }
